"""Datatables and related components used in different contexts.
"""
import grok
from waeup.interfaces import IUniversity, IFaculty, IDepartment
from waeup.widgets.interfaces import ITableProvider
from waeup.widgets.table import YUITable as Table
from waeup.widgets.table import Col

class DepartmentTableProvider(grok.Adapter):
    grok.context(IFaculty)
    grok.provides(ITableProvider)

    title = 'Departments'
    
    def __init__(self, context):
        self.context = context

    def getTable(self, view=None):
        data = self.context
        cols = (
            Col(
                header='Code', sortable=True,
                data = tuple(['<a href="%s">%s</a>' % (
                            data[x].code, data[x].code) for x in data])),
            Col(
                header='Title', sortable=True,
                data = tuple([data.getName(x) for x in data])),
            )
        self.table = Table(self.title, cols=cols)
        return self.table
